#ifndef FILELIST_H
#define FILELIST_H

/****************************************************************

    Copyright (c) 1996-1997 Fred Pesch

    This program is free software; you can redistribute it 
    and/or modify it under the terms of the GNU General 
    Public License as published by the Free Software 
    Foundation (version 2 of the License).

    This program is distributed in the hope that it will 
    be useful, but WITHOUT ANY WARRANTY; without even the 
    implied warranty of MERCHANTABILITY or FITNESS FOR A 
    PARTICULAR PURPOSE.  See the GNU General Public License 
    for more details.

    For a copy of the GNU General Public License, write to the 
    Free Software Foundation, Inc., 675 Mass Ave, Cambridge, 
    MA 02139, USA.

****************************************************************/

#include "dirlist.h"

/* primary file types */
typedef enum { DIRECTORY, SLINK_DIR, SLINK_FILE, EXECUTABLE_FILE, REGULAR_FILE, CHAR_DEVICE, BLOCK_DEVICE, FIFO, SOCKET, UNKNOWN } PRIMARY_FILE_TYPE;

typedef struct {

  SECURITY_FLAGS user;
  SECURITY_FLAGS group;
  SECURITY_FLAGS others;

  PRIMARY_FILE_TYPE type;

  int order;
  int readable;
  int executable;
  int selected;
  time_t modiftime;
  time_t changetime;
  time_t accesstime;
  off_t size;
  uid_t UID;
  gid_t GID;
  char *name;
} TFileEntry;

struct FileNode {
  TDirNode *parent;
  TFileEntry file;
  struct FileNode *next;
  struct FileNode *previous;
};

typedef struct FileNode TFileNode;

extern TFileNode *CreateFileList(TDirNode *parent);
extern void DestroyFileList(TFileNode *start);

#endif








